#-*- coding:utf-8 -*-
"""
$Id$
"""
from StringIO import StringIO
from zope.app import zapi
from zope.app.zptpage import ZPTPage
from zope.app.traversing.interfaces import ITraversable
from zope.app.form.browser import FileWidget
from zope.interface import implements
from zope.publisher.interfaces import IPublishTraverse
from zope.formlib import form
from zope import schema


from z3site import Theme
from z3site.interfaces import IThemeUtility
from z3site.utils import loadFromTarGz


theme_key = 'z3site_theme_name'
       
def get_theme(self):
    tu = zapi.getUtility(IThemeUtility, context=self.context)        
    if self.request.has_key(theme_key):
        theme = tu[ self.request[theme_key] ]
    else:
        theme = tu.values()[0]            
    return theme


class SkinView:
    def __getitem__(self, name):
        if name == 'page':
            theme = get_theme(self)
            ptpage = theme['site_layout.html']
            return ptpage.macros[name]

    
class ThemeView:
    implements(ITraversable, IPublishTraverse)
    
    def traverse(self, name, furtherPath):
        theme = get_theme(self)            
        obj = theme[name]
        
        if isinstance(obj, ZPTPage):
            page = obj        
            namespace = page.pt_getContext(self.context, self.request)
            namespace['view'] = self        
            return page.pt_render(namespace)
        
        return obj  
        
    def publishTraverse(self, request, name):
        theme = get_theme(self)                    
        return theme.get(name, None)


class ThemeLoadForm(form.Form):
    form_fields = form.Fields(schema.Bytes(__name__='file', title=u'File(.tar.gz)'), )
    form_fields['file'].custom_widget = FileWidget
    
    @form.action('Apply', condition=form.haveInputWidgets)
    def handle_apply_action(self, action, data):
        file = StringIO(data['file'])
        loadFromTarGz(file, self.context)
        file.close()
