#-*- coding:utf-8 -*-
"""
$Id$
"""
from zope.app import zapi
from zope.app.zptpage import ZPTPage

from z3site import Theme


class CreateDemoTheme:
    def create(self):
        templates = {}
        
        # layout
        src = u"""
        <metal:block define-macro="page">
        <html> DEMO LAYOUT
          <head>
             <tal:block replace="structure context/@@theme/myhead"/>             
          </head>
          <body>
            <table id="layout">
               <tr>
                  <td collspan="3">
                    <tal:block replace="structure context/@@theme/mytoolbar"/>
                  </td>
               </tr>
               <tr class="content">
                  <td class="navigation">
                    <div id="slotbox">
                      <tal:block replace="structure context/@@theme/navslot"/>
                    </div>
                  </td>
                  <td id="content">
                    <!-- message & body -->
                    <div metal:define-slot="message" id="message" />
                    <b metal:define-slot="body">BODY</b>
                    
                  </td>
                  <td class="navigation">
                    <tal:block replace="structure context/@@theme/addslot"/>
                  </td>
               </tr>
               <tr>
                  <td collspan="3">
                    <tal:block replace="structure context/@@theme/mytoolbar"/>
                  </td>
               </tr>
            </table>
          
          </body>
        </html>
        </metal:block>
        """
        templates['site_layout.html'] = src

        # myhead
        src = u"""
          <title>DEMO LAYOUT</title>
          <tal:block replace="structure provider:zope.app.boston.IHead" />
          <tal:block replace="structure provider:zope.app.boston.ICSS" />
          <tal:block replace="structure provider:zope.app.boston.IJavaScript" />
        """
        templates['myhead'] = src

        # mytoolbar
        src = u"""
          <tal:block replace="structure provider:zope.app.boston.IToolBar" />
        """
        templates['mytoolbar'] = src

        # navslot
        src = u"""
          NAVIGATION BOX 
          <tal:block replace="structure provider:zope.app.boston.ILeft" />
        """
        templates['navslot'] = src

        # addslot
        src = u"""
          ADD SLOT
          <tal:block replace="structure context/@@commonTasks|nothing" />
        """
        templates['addslot'] = src

        # create theme
        theme = Theme()
        self.context['test'] = theme
        theme = self.context['test']

        for name,src in templates.items():                                        
            page = ZPTPage()
            page.setSource(src)                   
            theme[name] = page 

        url = zapi.absoluteURL(theme, self.request)
        self.request.response.redirect(url)
        
        
            
