#-*- coding: utf-8 -*-
"""

$Id$
"""
import os
import unittest

from zope.app.file import Image
from zope.app.zptpage import ZPTPage

import z3site
from z3site.utils import loadFromTarGz

class TestLoadArchives(unittest.TestCase):

    def test_load_targz(self):
        root = {}
        file = open(os.path.join( z3site.__path__[0], 'tests', 'theme.tar.gz'), 'r')
        loadFromTarGz(file, root)

        self.assert_( root.has_key('theme'))

        files = { 'pic1.jpg': Image,
                  'pic2.gif': Image,
                  'page1.html': ZPTPage,
                  'site_layout.html': ZPTPage,
                  'style.css': ZPTPage,
                  }
        
        theme = root['theme']
        for k, cls in files.items():
            self.assert_( k in theme)
            self.assert_( isinstance(theme[k], cls) )
            
def test_suite():
    return unittest.TestSuite((
        unittest.makeSuite(TestLoadArchives),
        ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')
